aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--.gitmodules8
-rw-r--r--coin/provisioning/common/conan.ps133
-rw-r--r--coin/provisioning/common/helpers.ps120
-rw-r--r--coin/provisioning/common/ruby.ps17
-rw-r--r--coin/provisioning/qtci-linux-RHEL-6.6-x86_64/android_sdk_linux.sh101
-rw-r--r--coin/provisioning/qtci-linux-RHEL-6.6-x86_64/libusb.sh3
-rw-r--r--coin/provisioning/qtci-linux-RHEL-7.2-x86_64/disable_selinux.sh5
-rw-r--r--coin/provisioning/qtci-linux-RHEL-7.2-x86_64/install_icu.sh70
-rw-r--r--coin/provisioning/qtci-linux-RHEL-7.2-x86_64/rhel_packages.sh9
-rw-r--r--coin/provisioning/qtci-linux-Ubuntu-14.04-x86_64/libusb.sh3
-rw-r--r--coin/provisioning/qtci-windows-10-x86/conan.ps18
-rw-r--r--coin/provisioning/qtci-windows-10-x86/conanfiles/qtwebkit.txt20
-rw-r--r--coin/provisioning/qtci-windows-10-x86/ruby.ps11
-rw-r--r--coin/provisioning/qtci-windows-10-x86_64/conan.ps18
-rw-r--r--coin/provisioning/qtci-windows-10-x86_64/conanfiles/qtwebkit.txt20
-rw-r--r--coin/provisioning/qtci-windows-10-x86_64/ruby.ps11
-rw-r--r--configure.json7
-rw-r--r--qt.pro31
18 files changed, 347 insertions, 8 deletions
diff --git a/.gitmodules b/.gitmodules
index f9e798cc..79aca023 100644
--- a/.gitmodules
+++ b/.gitmodules
@@ -93,7 +93,7 @@
priority = 50
[submodule "qtlocation"]
depends = qtbase
- recommends = qtdeclarative qtquickcontrols qtserialport qtsystems
+ recommends = qtdeclarative qtquickcontrols qtserialport
path = qtlocation
url = ../qtlocation.git
branch = dev
@@ -183,7 +183,7 @@
path = qtserialbus
url = ../qtserialbus.git
branch = dev
- status = preview
+ status = addon
[submodule "qtserialport"]
depends = qtbase
path = qtserialport
@@ -263,7 +263,7 @@
branch = dev
status = addon
[submodule "qtpurchasing"]
- depends = qtbase
+ depends = qtbase qtandroidextras
recommends = qtdeclarative
path = qtpurchasing
url = ../qtpurchasing.git
@@ -302,7 +302,7 @@
path = qtscxml
url = ../qtscxml
branch = dev
- status = preview
+ status = addon
[submodule "qtspeech"]
depends = qtbase
recommends = qtdeclarative qtmultimedia
diff --git a/coin/provisioning/common/conan.ps1 b/coin/provisioning/common/conan.ps1
new file mode 100644
index 00000000..70962a41
--- /dev/null
+++ b/coin/provisioning/common/conan.ps1
@@ -0,0 +1,33 @@
+. "$PSScriptRoot\helpers.ps1"
+
+$installer = "c:\users\qt\downloads\conan-win_0_12_0.exe"
+
+Download https://s3-eu-west-1.amazonaws.com/conanio-production/downloads/conan-win_0_12_0.exe http://ci-files01-hki.ci.local/input/conan/conan-win_0_12_0.exe $installer
+Verify-Checksum $installer "719F30E6EED03149D75CDB28F80A7B873B43FF51"
+& $installer /DIR=C:\Utils\Conan /VERYSILENT
+
+[Environment]::SetEnvironmentVariable("CI_CONAN_BUILDINFO_DIR", "C:/Utils/conanbuildinfos", "Machine")
+
+function Run-Conan-Install
+{
+ Param (
+ [string]$ConanfilesDir,
+ [string]$BuildinfoDir,
+ [string]$Arch,
+ [string]$Compiler,
+ [string]$CompilerVersion
+ )
+
+ Get-ChildItem -Path "$ConanfilesDir\*.txt" |
+ ForEach-Object {
+ $outpwd = "C:\Utils\conanbuildinfos\$($BuildinfoDir)\$($_.BaseName)"
+ New-Item $outpwd -Type directory -Force
+ Start-Process `
+ "C:\Utils\Conan\conan\conan.exe" `
+ -WorkingDirectory $outpwd `
+ -ArgumentList "install -i -f $($_.FullName)", `
+ '-s', ('compiler="' + $Compiler + '"'), `
+ "-s os=Windows -s arch=$($Arch) -s compiler.version=$($CompilerVersion)" `
+ -NoNewWindow -Wait
+ }
+}
diff --git a/coin/provisioning/common/helpers.ps1 b/coin/provisioning/common/helpers.ps1
index d7b957f3..055ce0a7 100644
--- a/coin/provisioning/common/helpers.ps1
+++ b/coin/provisioning/common/helpers.ps1
@@ -29,3 +29,23 @@ function Extract-Zip
$destinationFolder = $shell.Namespace($Destination)
$destinationFolder.CopyHere($zipfile.Items(), 16)
}
+
+function BadParam
+{
+ Param ([string]$Description)
+ throw("You must specify $Description")
+}
+
+function Download
+{
+ Param (
+ [string] $OfficialUrl = $(BadParam("the official download URL")),
+ [string] $CachedUrl = $(BadParam("the locally cached URL")),
+ [string] $Destination = $(BadParam("a download target location"))
+ )
+ try {
+ Invoke-WebRequest -UseBasicParsing $CachedUrl -OutFile $Destination
+ } catch {
+ Invoke-WebRequest -UseBasicParsing $OfficialUrl -OutFile $Destination
+ }
+}
diff --git a/coin/provisioning/common/ruby.ps1 b/coin/provisioning/common/ruby.ps1
new file mode 100644
index 00000000..343bacfc
--- /dev/null
+++ b/coin/provisioning/common/ruby.ps1
@@ -0,0 +1,7 @@
+. "$PSScriptRoot\helpers.ps1"
+
+$installer = "c:\users\qt\downloads\rubyinstaller-2.3.1.exe"
+
+Download https://dl.bintray.com/oneclick/rubyinstaller/rubyinstaller-2.3.1.exe http://ci-files01-hki.ci.local/input/ruby/rubyinstaller-2.3.1.exe $installer
+Verify-Checksum $installer "FF377F6F313849C3B0CD72EEC1EFFA436F0E4A36"
+& $installer /DIR=C:\ruby /VERYSILENT
diff --git a/coin/provisioning/qtci-linux-RHEL-6.6-x86_64/android_sdk_linux.sh b/coin/provisioning/qtci-linux-RHEL-6.6-x86_64/android_sdk_linux.sh
new file mode 100644
index 00000000..7f1cf05b
--- /dev/null
+++ b/coin/provisioning/qtci-linux-RHEL-6.6-x86_64/android_sdk_linux.sh
@@ -0,0 +1,101 @@
+#!/bin/env bash
+
+#############################################################################
+##
+## Copyright (C) 2016 The Qt Company Ltd.
+## Contact: http://www.qt.io/licensing/
+##
+## This file is part of the test suite of the Qt Toolkit.
+##
+## $QT_BEGIN_LICENSE:LGPL21$
+## Commercial License Usage
+## Licensees holding valid commercial Qt licenses may use this file in
+## accordance with the commercial license agreement provided with the
+## Software or, alternatively, in accordance with the terms contained in
+## a written agreement between you and The Qt Company. For licensing terms
+## and conditions see http://www.qt.io/terms-conditions. For further
+## information use the contact form at http://www.qt.io/contact-us.
+##
+## GNU Lesser General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU Lesser
+## General Public License version 2.1 or version 3 as published by the Free
+## Software Foundation and appearing in the file LICENSE.LGPLv21 and
+## LICENSE.LGPLv3 included in the packaging of this file. Please review the
+## following information to ensure the GNU Lesser General Public License
+## requirements will be met: https://www.gnu.org/licenses/lgpl.html and
+## http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
+##
+## As a special exception, The Qt Company gives you certain additional
+## rights. These rights are described in The Qt Company LGPL Exception
+## version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
+##
+## $QT_END_LICENSE$
+##
+#############################################################################
+
+# This script install Android sdk and ndk.
+
+# It also runs update for SDK API level 18, latest SDK tools, latest platform-tools and build-tools version 23.0.3
+
+# Build-tools version 23.0.3 is the latest usable version for Red Hat 6. Newer version of build-tools, version 24.x.x, requires GLIBC_2.14, which is not available in Red Hat 6.
+
+# Android 16 is the minimum requirement for Qt 5.7 applications, but we need something more recent than that for building Qt itself.
+# E.g The Bluetooth features that require Android 18 will disable themselves dynamically when running on an Android 16 device.
+# That's why we need to use Andoid-18 API version and decision was made to use it also with Qt 5.6.
+
+set -e
+targetFolder="/opt/android"
+baseUrl="http://ci-files01-hki.ci.local/input/android"
+
+# SDK
+sdkVersion="android-sdk_r24.4.1-linux.tgz"
+sdkBuildToolsVersion="23.0.3"
+sdkApiLevel="android-18"
+sdkUrl="$baseUrl/$sdkVersion"
+sdkSha1="725bb360f0f7d04eaccff5a2d57abdd49061326d"
+sdkTargetFile="$targetFolder/$sdkVersion"
+sdkExtract="tar -C $targetFolder -zxf $sdkTargetFile"
+sdkFolderName="android-sdk-linux"
+sdkName="sdk"
+
+# NDK
+ndkVersion="android-ndk-r10e-linux-x86_64.zip"
+ndkUrl="$baseUrl/$ndkVersion"
+ndkSha1="f692681b007071103277f6edc6f91cb5c5494a32"
+ndkTargetFile="$targetFolder/$ndkVersion"
+ndkExtract="unzip $ndkTargetFile -d $targetFolder"
+ndkFolderName="android-ndk-r10e"
+ndkName="ndk"
+
+function InstallAndroidPackage {
+ targetFolder=$1
+ version=$2
+ url=$3
+ sha1=$4
+ targetFile=$5
+ extract=$6
+ folderName=$7
+ name=$8
+
+ sudo wget --tries=5 --waitretry=5 --output-document=$targetFile $url || echo "Failed to download '$url' multiple times"
+ echo "$sha1 $targetFile" | sha1sum --check || echo "Failed to check sha1sum"
+ sudo chmod 755 $targetFile
+ sudo $extract || echo "Failed to extract $url"
+ sudo chown -R qt:users $targetFolder/$folderName
+ sudo mv $targetFolder/$folderName $targetFolder/$name || echo "Failed to rename $name"
+ sudo rm -fr $targetFolder/$version
+}
+
+sudo mkdir $targetFolder
+# Install Android SDK
+echo "Installing Android SDK version $sdkVersion..."
+InstallAndroidPackage $targetFolder $sdkVersion $sdkUrl $sdkSha1 $sdkTargetFile "$sdkExtract" $sdkFolderName $sdkName
+
+# Install Android NDK
+echo "Installing Android NDK version $ndkVersion..."
+InstallAndroidPackage $targetFolder $ndkVersion $ndkUrl $ndkSha1 $ndkTargetFile "$ndkExtract" $ndkFolderName $ndkName
+
+# run update for Android SDK and install SDK API version 18, latest SDK tools, platform-tools and build-tools
+echo "Running Android SDK update for API version 18, SDK-tools, platform-tools and build-tools-$sdkBuildToolsVersion..."
+echo "y" |$targetFolder/sdk/tools/android update sdk --no-ui --all --filter $sdkApiLevel,tools,platform-tools,build-tools-$sdkBuildToolsVersion || echo "Failed to run update"
+
diff --git a/coin/provisioning/qtci-linux-RHEL-6.6-x86_64/libusb.sh b/coin/provisioning/qtci-linux-RHEL-6.6-x86_64/libusb.sh
new file mode 100644
index 00000000..229e259f
--- /dev/null
+++ b/coin/provisioning/qtci-linux-RHEL-6.6-x86_64/libusb.sh
@@ -0,0 +1,3 @@
+#!/bin/env bash
+# Required for tqtc-boot2qt/qdb
+sudo yum install -y libusb1-devel
diff --git a/coin/provisioning/qtci-linux-RHEL-7.2-x86_64/disable_selinux.sh b/coin/provisioning/qtci-linux-RHEL-7.2-x86_64/disable_selinux.sh
new file mode 100644
index 00000000..30162166
--- /dev/null
+++ b/coin/provisioning/qtci-linux-RHEL-7.2-x86_64/disable_selinux.sh
@@ -0,0 +1,5 @@
+# We need to disable selinux while we are overwriting some binaries
+# required by it. If this is not done, ICU provisioning will create
+# template that is not booting.
+
+sudo sed -i s/SELINUX=enforcing/SELINUX=disabled/g /etc/selinux/config
diff --git a/coin/provisioning/qtci-linux-RHEL-7.2-x86_64/install_icu.sh b/coin/provisioning/qtci-linux-RHEL-7.2-x86_64/install_icu.sh
new file mode 100644
index 00000000..682ea91c
--- /dev/null
+++ b/coin/provisioning/qtci-linux-RHEL-7.2-x86_64/install_icu.sh
@@ -0,0 +1,70 @@
+#!/bin/env bash
+
+#############################################################################
+##
+## Copyright (C) 2016 The Qt Company Ltd.
+## Contact: http://www.qt.io/licensing/
+##
+## This file is part of the test suite of the Qt Toolkit.
+##
+## $QT_BEGIN_LICENSE:LGPL21$
+## Commercial License Usage
+## Licensees holding valid commercial Qt licenses may use this file in
+## accordance with the commercial license agreement provided with the
+## Software or, alternatively, in accordance with the terms contained in
+## a written agreement between you and The Qt Company. For licensing terms
+## and conditions see http://www.qt.io/terms-conditions. For further
+## information use the contact form at http://www.qt.io/contact-us.
+##
+## GNU Lesser General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU Lesser
+## General Public License version 2.1 or version 3 as published by the Free
+## Software Foundation and appearing in the file LICENSE.LGPLv21 and
+## LICENSE.LGPLv3 included in the packaging of this file. Please review the
+## following information to ensure the GNU Lesser General Public License
+## requirements will be met: https://www.gnu.org/licenses/lgpl.html and
+## http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
+##
+## As a special exception, The Qt Company gives you certain additional
+## rights. These rights are described in The Qt Company LGPL Exception
+## version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
+##
+## $QT_END_LICENSE$
+##
+#############################################################################
+
+# This script installs the right ICU version
+
+set -e
+icuVersion="56.1"
+icuLocation="/usr/lib64"
+sha1="6dd9ca6b185681a7ddc4bb94fd7fced27647a21c"
+
+function Install7ZPackageFromURL {
+ url=$1
+ expectedSha1=$2
+ targetDirectory=$3
+
+ targetFile=`mktemp` || echo "Failed to create temporary file"
+ wget --tries=5 --waitretry=5 --output-document=$targetFile $url || echo "Failed to download '$url' multiple times"
+ echo "$expectedSha1 $targetFile" | sha1sum --check || echo "Failed to check sha1sum"
+ sudo /usr/local/bin/7z x -yo$targetDirectory $targetFile || echo "Failed to unzip $url archive"
+ rm $targetFile
+}
+
+echo "Installing custom ICU $icuVersion $sha1 packages on RHEL to $icuLocation"
+
+baseBinaryPackageURL="http://master.qt.io/development_releases/prebuilt/icu/prebuilt/$icuVersion/icu-linux-g++-Rhel7.2-x64.7z"
+Install7ZPackageFromURL $baseBinaryPackageURL $sha1 "/usr/lib64"
+
+echo "Installing custom ICU devel packages on RHEL"
+
+sha1Dev="bffde26cdea752bee0edd281820c57f1adac3864"
+develPackageURL="http://master.qt.io/development_releases/prebuilt/icu/prebuilt/$icuVersion/icu-linux-g++-Rhel7.2-x64-devel.7z"
+tempDir=`mktemp -d` || echo "Failed to create temporary directory"
+trap "sudo rm -fr $tempDir" EXIT
+Install7ZPackageFromURL $develPackageURL $sha1Dev $tempDir
+sudo cp -a $tempDir/lib/* /usr/lib64
+sudo cp -a $tempDir/* /usr/
+
+sudo /sbin/ldconfig
diff --git a/coin/provisioning/qtci-linux-RHEL-7.2-x86_64/rhel_packages.sh b/coin/provisioning/qtci-linux-RHEL-7.2-x86_64/rhel_packages.sh
new file mode 100644
index 00000000..c322bcbf
--- /dev/null
+++ b/coin/provisioning/qtci-linux-RHEL-7.2-x86_64/rhel_packages.sh
@@ -0,0 +1,9 @@
+# gstreamer 1 for QtMultimedia
+# gtk3 style for QtGui/QStyle
+# libusb1 for tqtc-boot2qt/qdb
+
+sudo yum install -y \
+ gstreamer1-devel gstreamer1-plugins-base-devel \
+ gtk3-devel \
+ libusb1-devel
+
diff --git a/coin/provisioning/qtci-linux-Ubuntu-14.04-x86_64/libusb.sh b/coin/provisioning/qtci-linux-Ubuntu-14.04-x86_64/libusb.sh
new file mode 100644
index 00000000..f48a6e36
--- /dev/null
+++ b/coin/provisioning/qtci-linux-Ubuntu-14.04-x86_64/libusb.sh
@@ -0,0 +1,3 @@
+#!/bin/env bash
+# Required for tqtc-boot2qt/qdb
+sudo apt-get install -y libusb-1.0-0-dev
diff --git a/coin/provisioning/qtci-windows-10-x86/conan.ps1 b/coin/provisioning/qtci-windows-10-x86/conan.ps1
new file mode 100644
index 00000000..718d25de
--- /dev/null
+++ b/coin/provisioning/qtci-windows-10-x86/conan.ps1
@@ -0,0 +1,8 @@
+. "$PSScriptRoot\..\common\conan.ps1"
+
+Run-Conan-Install `
+ -ConanfilesDir "$PSScriptRoot\conanfiles" `
+ -BuildinfoDir MSVC2015-x86 `
+ -Arch x86 `
+ -Compiler "Visual Studio" `
+ -CompilerVersion 14
diff --git a/coin/provisioning/qtci-windows-10-x86/conanfiles/qtwebkit.txt b/coin/provisioning/qtci-windows-10-x86/conanfiles/qtwebkit.txt
new file mode 100644
index 00000000..d1fcbfba
--- /dev/null
+++ b/coin/provisioning/qtci-windows-10-x86/conanfiles/qtwebkit.txt
@@ -0,0 +1,20 @@
+[requires]
+cmake_installer/0.1@lasote/testing
+icu/57.1@Vitallium/stable
+libxml2-qt/2.9.4@Vitallium/stable
+libxslt-qt/1.1.29@Vitallium/stable
+
+[generators]
+cmake
+virtualenv
+
+[options]
+cmake_installer:version=3.5.2
+icu:shared=True
+libxml2-qt:shared=False
+libxslt-qt:shared=False
+
+[imports]
+bin, icudt57.dll -> ./bin
+bin, icuin57.dll -> ./bin
+bin, icuuc57.dll -> ./bin
diff --git a/coin/provisioning/qtci-windows-10-x86/ruby.ps1 b/coin/provisioning/qtci-windows-10-x86/ruby.ps1
new file mode 100644
index 00000000..587a4c10
--- /dev/null
+++ b/coin/provisioning/qtci-windows-10-x86/ruby.ps1
@@ -0,0 +1 @@
+. "$PSScriptRoot\..\common\ruby.ps1"
diff --git a/coin/provisioning/qtci-windows-10-x86_64/conan.ps1 b/coin/provisioning/qtci-windows-10-x86_64/conan.ps1
new file mode 100644
index 00000000..04887712
--- /dev/null
+++ b/coin/provisioning/qtci-windows-10-x86_64/conan.ps1
@@ -0,0 +1,8 @@
+. "$PSScriptRoot\..\common\conan.ps1"
+
+Run-Conan-Install `
+ -ConanfilesDir "$PSScriptRoot\conanfiles" `
+ -BuildinfoDir MSVC2015-x86_64 `
+ -Arch x86_64 `
+ -Compiler "Visual Studio" `
+ -CompilerVersion 14
diff --git a/coin/provisioning/qtci-windows-10-x86_64/conanfiles/qtwebkit.txt b/coin/provisioning/qtci-windows-10-x86_64/conanfiles/qtwebkit.txt
new file mode 100644
index 00000000..d1fcbfba
--- /dev/null
+++ b/coin/provisioning/qtci-windows-10-x86_64/conanfiles/qtwebkit.txt
@@ -0,0 +1,20 @@
+[requires]
+cmake_installer/0.1@lasote/testing
+icu/57.1@Vitallium/stable
+libxml2-qt/2.9.4@Vitallium/stable
+libxslt-qt/1.1.29@Vitallium/stable
+
+[generators]
+cmake
+virtualenv
+
+[options]
+cmake_installer:version=3.5.2
+icu:shared=True
+libxml2-qt:shared=False
+libxslt-qt:shared=False
+
+[imports]
+bin, icudt57.dll -> ./bin
+bin, icuin57.dll -> ./bin
+bin, icuuc57.dll -> ./bin
diff --git a/coin/provisioning/qtci-windows-10-x86_64/ruby.ps1 b/coin/provisioning/qtci-windows-10-x86_64/ruby.ps1
new file mode 100644
index 00000000..587a4c10
--- /dev/null
+++ b/coin/provisioning/qtci-windows-10-x86_64/ruby.ps1
@@ -0,0 +1 @@
+. "$PSScriptRoot\..\common\ruby.ps1"
diff --git a/configure.json b/configure.json
new file mode 100644
index 00000000..f437252f
--- /dev/null
+++ b/configure.json
@@ -0,0 +1,7 @@
+{
+ "commandline": {
+ "options": {
+ "skip": "addString"
+ }
+ }
+}
diff --git a/qt.pro b/qt.pro
index f8d3d4d3..1915fc2c 100644
--- a/qt.pro
+++ b/qt.pro
@@ -1,12 +1,10 @@
# Create the super cache so modules will add themselves to it.
cache(, super)
-CONFIG += build_pass # hack to disable the .qmake.super auto-add
-load(qt_build_config)
-CONFIG -= build_pass # unhack, as it confuses Qt Creator
-
TEMPLATE = subdirs
+CONFIG += prepare_docs qt_docs_targets
+
# Extract submodules from .gitmodules.
lines = $$cat(.gitmodules, lines)
for (line, lines) {
@@ -26,6 +24,29 @@ for (line, lines) {
}
QMAKE_INTERNAL_INCLUDED_FILES += $$PWD/.gitmodules
+QT_SKIP_MODULES =
+uikit {
+ QT_SKIP_MODULES += qtdoc qtmacextras qtserialport qtwebkit qtwebkit-examples
+ !ios: QT_SKIP_MODULES += qtscript
+}
+
+# This is a bit hacky, but a proper implementation is not worth it.
+args = $$QMAKE_EXTRA_ARGS
+for (ever) {
+ isEmpty(args): break()
+ a = $$take_first(args)
+
+ equals(a, -skip) {
+ isEmpty(args): break()
+ m = $$take_first(args)
+ contains(m, -.*): next()
+ m ~= s/^(qt)?/qt/
+ !contains(modules, $$m): \
+ error("-skip command line argument used with non-existent module '$$m'.")
+ QT_SKIP_MODULES += $$m
+ }
+}
+
modules = $$sort_depends(modules, module., .depends .recommends)
modules = $$reverse(modules)
for (mod, modules) {
@@ -72,3 +93,5 @@ for (mod, modules) {
SUBDIRS += $$mod
}
+
+load(qt_configure)